/*********************************************************************
* 	DeDotMT for AviUtl
* 								ver. 0.02b1
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
* http://www.gnu.org/copyleft/gpl.html .
* 
* 
* ===== DeDotMT for AviUtl ===========
* [2008]
*	11/07:	J(0.01)
*	11/27:	oOC(0.02b1)
*			ASYC
*	12/04	oOC(0.02b2)
*			ASYC
*			
*
*
*********************************************************************/
#include <windows.h>
#include <math.h>
#if defined(__INTEL_COMPILER)
#include <ia32intrin.h>
#if defined(SSSE3)
#include <tmmintrin.h>
#elif defined(SSE3)
#include <pmmintrin.h>
#else
#include <emmintrin.h>
#endif
#else
#include <intrin.h>
#define _rdtsc __rdtsc
#endif
#include "filter.h"

//----------------------------
//	O[oϐ
//----------------------------

WORD *pPP, *pP, *pC, *pN, *pNN, *pD;
int nPitch;
int w_simd;
int w_sup;

_MM_ALIGN16 __m128i m_luma2D;
_MM_ALIGN16 __m128i m_lumaT;
_MM_ALIGN16 __m128i m_maskSup;

typedef struct {
	FILTER				*fp;
	FILTER_PROC_INFO	*fpip;
} FILTER_PARAM;

//8P(16rbg)SSE2p萔
static const __m128i c0 = {0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0};
static const __m128i maskTbl[8] = {
	{0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00},
	{0xFF,0xFF, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00},
	{0xFF,0xFF, 0xFF,0xFF, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00},
	{0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00},
	{0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00},
	{0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0x00,0x00, 0x00,0x00, 0x00,0x00},
	{0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0x00,0x00, 0x00,0x00},
	{0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0xFF,0xFF, 0x00,0x00}
};

//----------------------------
//	FILTER_DLL\
//----------------------------
char filtername[] = "DeDotMT";
#if defined(SSSE3)
char filterinfo[] = "DeDotMT for SSSE3 for AviUtl ver 0.02b2 by BS";
#elif defined(SSE3)
char filterinfo[] = "DeDotMT for SSE3 for AviUtl ver 0.02b2 by BS";
#elif defined(SSE2)
char filterinfo[] = "DeDotMT for SSE2 for AviUtl ver 0.02b2 by BS";
#else
#error "Please define SSE2/SSE3/SSSE3."
#endif
#define track_N 2
#if track_N
TCHAR *track_name[]   = { "luma2D", "lumaT"};	// gbNo[̖O
int   track_default[] = {      20 ,     20 };	// gbNo[̏l
int   track_s[]       = {       0 ,      0 };	// gbNo[̉l
int   track_e[]       = {     255 ,    255 };	// gbNo[̏l

#define tLUMA2D		0
#define tLUMAT		1
#endif

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,
	NULL,NULL,      	// ݒEChẼTCY
	filtername,     	// tB^̖O
	track_N,        	// gbNo[̐
#if track_N
	track_name,     	// gbNo[̖OS
	track_default,  	// gbNo[̏lS
	track_s,track_e,	// gbNo[̐l̉
#else
	NULL,NULL,NULL,NULL,
#endif
#if check_N
	check_N,      	// `FbN{bNX̐
	check_name,   	// `FbN{bNX̖OS
	check_default,	// `FbN{bNX̏lS
#else
	0, 
	NULL,NULL,
#endif
	func_proc,   	// tB^֐
	NULL,NULL,   	// Jn,IɌĂ΂֐
	NULL,        	// ݒ肪ύXꂽƂɌĂ΂֐
	NULL,        	// ݒEBhEvV[W
	NULL,NULL,   	// VXeŎgp
	NULL,NULL,   	// gf[^̈
	filterinfo,  	// tB^
	NULL,			// Z[uJnOɌĂ΂֐
	NULL,			// Z[uIɌĂ΂֐
	NULL,NULL,NULL,	// VXeŎgp
	NULL,			// g̈揉l
};

//----------------------------
//	SIMDߌ݊
//----------------------------
#if defined(SSE2)
#define _mm_load_esi32(src) (_mm_castps_si128(_mm_load_ss((float*)(src))));
#define _mm_store_esi32(dst, val) _mm_store_ss((float*)(dst), _mm_castsi128_ps(val))
#if !defined(SSE3)
#define _mm_lddqu_si128 _mm_loadu_si128
static inline __m128 _mm_hadd_ps(__m128 a, __m128 b)
{
	__m128 c = a;
	a = _mm_shuffle_ps(a, b, _MM_SHUFFLE(2,0,2,0));
	c = _mm_shuffle_ps(c, b, _MM_SHUFFLE(3,1,3,1));
	return _mm_add_ps(a, c);
}
#endif
#if !defined(SSSE3)
static inline __m128i _mm_abs_epi16(__m128i __m1)
{
	register __m128i __m2 = _mm_cmpgt_epi16(c0, __m1);
	__m1 = _mm_xor_si128(__m1, __m2);
	return	_mm_sub_epi16(__m1, __m2);
}
static inline __m128i _mm_hadd_epi32(__m128i a, __m128i b)
{
	__m128i c = a;
	a = _mm_castps_si128(_mm_shuffle_ps(_mm_castsi128_ps(a), _mm_castsi128_ps(b), _MM_SHUFFLE(2,0,2,0)));
	c = _mm_castps_si128(_mm_shuffle_ps(_mm_castsi128_ps(c), _mm_castsi128_ps(b), _MM_SHUFFLE(3,1,3,1)));
	return _mm_add_epi32(a, c);
}
#endif
#endif

#if defined(DEBUG)
/*---------------------------------------------------------------------------
// for calcurate performance
//-------------------------------------------------------------------------*/
#include "text.h"
#include <stdio.h>
#include <stdlib.h>
void debug_info(FILTER_PROC_INFO *fpip, EXFUNC *func)
{
	static PIXEL bg = {255,  0,  0};
	static PIXEL fg = {255,255,255};
	char stmp[1024];
	sprintf(stmp, "Frame =%d\npPP : %08X\npP  : %08X\npC  : %08X\npN  : %08X\npNN : %08X"
		,fpip->frame, (int)pPP, (int)pP , (int)pC , (int)pN ,(int)pNN);
	show_text(stmp, fpip->ycp_edit, 256, 256, fpip->max_w, &bg, &fg, func);
}
#endif
/*********************************************************************
*	DLL Export
*********************************************************************/
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

//---------------------------------------------------------------------
//		tB^ݒύX֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
	m_luma2D   = _mm_set1_epi16(fp->track[tLUMA2D]<<4);
	m_lumaT    = _mm_set1_epi16(fp->track[tLUMAT]<<4);

	return TRUE;
}

/*--------------------------------------------------------------------
*	DeDot	hbgWQNXJ[	(MT)
*-------------------------------------------------------------------*/
void DeDot(FILTER_PROC_INFO *fpip, int y_start, int y_end)
{
	int ofs = fpip->max_w * y_start * 3;
	__m128i XMM7 = _mm_setzero_si128();
	int x, y;

	if(y==1)
	{
		memcpy(pD            , pC            , sizeof(PIXEL_YC)*fpip->w);
	}
	for(y=y_start ; y<y_end; y++)
	{
		for(x=0 ; x<w_simd ; x+=8)
		{
			int a, b;
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5, XMM6;
			XMM0 = _mm_load_si128((__m128i*)(pP +ofs));
			XMM1 = _mm_load_si128((__m128i*)(pC +ofs));
			XMM2 = _mm_load_si128((__m128i*)(pN +ofs));
			XMM5 = _mm_lddqu_si128((__m128i*)(pC +ofs-3));
			XMM6 = _mm_lddqu_si128((__m128i*)(pC +ofs+3));
			XMM3 = XMM0;
			XMM4 = XMM2;
			XMM0 = _mm_sub_epi16(XMM0, XMM1);
			XMM2 = _mm_sub_epi16(XMM2, XMM1);
			XMM3 = _mm_add_epi16(XMM3, XMM1);
			XMM4 = _mm_add_epi16(XMM4, XMM1);
			XMM0 = _mm_abs_epi16(XMM0);
			XMM2 = _mm_abs_epi16(XMM2);
			XMM3 = _mm_srai_epi16(XMM3, 1);
			XMM4 = _mm_srai_epi16(XMM4, 1);
			XMM0 = _mm_subs_epu16(XMM0, XMM2);
			XMM2 = _mm_load_si128((__m128i*)(pC +ofs-nPitch));
			XMM0 = _mm_cmpeq_epi16(XMM0, XMM7);
			XMM3 = _mm_and_si128(XMM3, XMM0);
			XMM0 = _mm_andnot_si128(XMM0, XMM4);
			XMM4 = _mm_load_si128((__m128i*)(pC +ofs+nPitch));
			XMM0 = _mm_or_si128(XMM0, XMM3);
			XMM3 = XMM1;
			XMM5 = _mm_add_epi16(XMM5, XMM6);
			XMM2 = _mm_add_epi16(XMM2, XMM4);
			XMM3 = _mm_add_epi16(XMM3, XMM3);
			XMM5 = _mm_sub_epi16(XMM5, XMM3);
			XMM2 = _mm_sub_epi16(XMM2, XMM3);
			XMM5 = _mm_abs_epi16(XMM5);
			XMM2 = _mm_abs_epi16(XMM2);
			XMM5 = _mm_subs_epu16(XMM5, m_luma2D);
			XMM2 = _mm_subs_epu16(XMM2, m_luma2D);
			XMM5 = _mm_or_si128(XMM5, XMM2);
			XMM5 = _mm_cmpeq_epi16(XMM5, XMM7);
			XMM5 = _mm_cmpeq_epi16(XMM5, XMM7);
			XMM6 = _mm_load_si128((__m128i*)(pP +ofs));
			XMM4 = _mm_load_si128((__m128i*)(pPP+ofs));
			XMM3 = _mm_load_si128((__m128i*)(pNN+ofs));
			XMM2 = _mm_load_si128((__m128i*)(pN +ofs));
			XMM6 = _mm_sub_epi16(XMM6, XMM2);
			XMM4 = _mm_sub_epi16(XMM4, XMM1);
			XMM3 = _mm_sub_epi16(XMM3, XMM1);
			XMM6 = _mm_abs_epi16(XMM6);
			XMM4 = _mm_abs_epi16(XMM4);
			XMM3 = _mm_abs_epi16(XMM3);
			XMM6 = _mm_subs_epu16(XMM6, m_lumaT);
			XMM4 = _mm_subs_epu16(XMM4, m_lumaT);
			XMM3 = _mm_subs_epu16(XMM3, m_lumaT);
			XMM6 = _mm_cmpeq_epi16(XMM6, XMM7);
			XMM4 = _mm_cmpeq_epi16(XMM4, XMM7);
			XMM3 = _mm_cmpeq_epi16(XMM3, XMM7);
			XMM6 = _mm_and_si128(XMM6, XMM4);
			XMM3 = _mm_and_si128(XMM3, XMM5);
			XMM6 = _mm_and_si128(XMM6, XMM3);
			XMM0 = _mm_and_si128(XMM0, XMM6);
			XMM6 = _mm_andnot_si128(XMM6, XMM1);
			XMM0 = _mm_or_si128(XMM0, XMM6);
			_mm_store_si128((__m128i*)(pD+ofs), XMM0);
			ofs += 8;
		}
		if(w_sup!=0)
		{
			int a, b;
			__m128i XMM0, XMM1, XMM2, XMM3, XMM4, XMM5, XMM6;
			XMM0 = _mm_load_si128((__m128i*)(pP +ofs));
			XMM1 = _mm_load_si128((__m128i*)(pC +ofs));
			XMM2 = _mm_load_si128((__m128i*)(pN +ofs));
			XMM5 = _mm_lddqu_si128((__m128i*)(pC +ofs-3));
			XMM6 = _mm_lddqu_si128((__m128i*)(pC +ofs+3));
			XMM3 = XMM0;
			XMM4 = XMM2;
			XMM0 = _mm_sub_epi16(XMM0, XMM1);
			XMM2 = _mm_sub_epi16(XMM2, XMM1);
			XMM3 = _mm_add_epi16(XMM3, XMM1);
			XMM4 = _mm_add_epi16(XMM4, XMM1);
			XMM0 = _mm_abs_epi16(XMM0);
			XMM2 = _mm_abs_epi16(XMM2);
			XMM3 = _mm_srai_epi16(XMM3, 1);
			XMM4 = _mm_srai_epi16(XMM4, 1);
			XMM0 = _mm_subs_epu16(XMM0, XMM2);
			XMM2 = _mm_load_si128((__m128i*)(pC +ofs-nPitch));
			XMM0 = _mm_cmpeq_epi16(XMM0, XMM7);
			XMM3 = _mm_and_si128(XMM3, XMM0);
			XMM0 = _mm_andnot_si128(XMM0, XMM4);
			XMM4 = _mm_load_si128((__m128i*)(pC +ofs+nPitch));
			XMM0 = _mm_or_si128(XMM0, XMM3);
			XMM3 = XMM1;
			XMM5 = _mm_add_epi16(XMM5, XMM6);
			XMM2 = _mm_add_epi16(XMM2, XMM4);
			XMM3 = _mm_add_epi16(XMM3, XMM3);
			XMM5 = _mm_sub_epi16(XMM5, XMM3);
			XMM2 = _mm_sub_epi16(XMM2, XMM3);
			XMM5 = _mm_abs_epi16(XMM5);
			XMM2 = _mm_abs_epi16(XMM2);
			XMM5 = _mm_subs_epu16(XMM5, m_luma2D);
			XMM2 = _mm_subs_epu16(XMM2, m_luma2D);
			XMM5 = _mm_or_si128(XMM5, XMM2);
			XMM5 = _mm_cmpeq_epi16(XMM5, XMM7);
			XMM5 = _mm_cmpeq_epi16(XMM5, XMM7);
			XMM6 = _mm_load_si128((__m128i*)(pP +ofs));
			XMM4 = _mm_load_si128((__m128i*)(pPP+ofs));
			XMM3 = _mm_load_si128((__m128i*)(pNN+ofs));
			XMM2 = _mm_load_si128((__m128i*)(pN +ofs));
			XMM6 = _mm_sub_epi16(XMM6, XMM2);
			XMM4 = _mm_sub_epi16(XMM4, XMM1);
			XMM3 = _mm_sub_epi16(XMM3, XMM1);
			XMM6 = _mm_abs_epi16(XMM6);
			XMM4 = _mm_abs_epi16(XMM4);
			XMM3 = _mm_abs_epi16(XMM3);
			XMM6 = _mm_subs_epu16(XMM6, m_lumaT);
			XMM4 = _mm_subs_epu16(XMM4, m_lumaT);
			XMM3 = _mm_subs_epu16(XMM3, m_lumaT);
			XMM6 = _mm_cmpeq_epi16(XMM6, XMM7);
			XMM4 = _mm_cmpeq_epi16(XMM4, XMM7);
			XMM3 = _mm_cmpeq_epi16(XMM3, XMM7);
			XMM6 = _mm_and_si128(XMM6, XMM4);
			XMM3 = _mm_and_si128(XMM3, XMM5);
			XMM6 = _mm_and_si128(XMM6, XMM3);
			XMM0 = _mm_and_si128(XMM0, XMM6);
			XMM6 = _mm_andnot_si128(XMM6, XMM1);
			XMM0 = _mm_or_si128(XMM0, XMM6);
			_mm_maskmoveu_si128(XMM0, m_maskSup, (char*)(pD+ofs));
			ofs += w_sup;
		}
		ofs += (fpip->max_w - fpip->w) * 3;
	}
	if(y==fpip->h-1)
	{
		memcpy(pD+ofs, pC+ofs, sizeof(PIXEL_YC)*fpip->w);
	}
}

//}`Xbh
static void DeDot_MT(int thread_id,int thread_num,void *param1,void *param2)
{
	FILTER *fp				= ((FILTER_PARAM *)param1)->fp;
	FILTER_PROC_INFO *fpip	= ((FILTER_PARAM *)param1)->fpip;

	//摜cɃXbhď͈͌vZ
	int y_start = ( fpip->h * thread_id     ) / thread_num;
	int y_end   = (( fpip->h * (thread_id+1) ) / thread_num);

	if(y_start==0)
		y_start ++;
	if(y_end==fpip->h)
		y_end --;

	DeDot(fpip, y_start, y_end);
}

/*====================================================================
*	tB^֐
*===================================================================*/
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	FILTER_PARAM	filter_param	= {fp, fpip};

	m_luma2D   = _mm_set1_epi16(fp->track[tLUMA2D]<<4);
	m_lumaT    = _mm_set1_epi16(fp->track[tLUMAT]<<4);

	w_simd = (fpip->w*3)&(~7);
	w_sup  = (fpip->w*3)&7;

	m_maskSup = maskTbl[w_sup];

	// Ot[LbVݒ
	fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->h, 5, NULL);

	// Ot[|C^擾
	pPP = (WORD*)fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, fpip->frame-2, NULL, NULL);
	pP  = (WORD*)fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, fpip->frame-1, NULL, NULL);
	pC  = (WORD*)fpip->ycp_edit;
	pN  = (WORD*)fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, fpip->frame+1, NULL, NULL);
	pNN = (WORD*)fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, fpip->frame+2, NULL, NULL);

	if(pP  == NULL)
		if(pN ==NULL)
			pP  = pC;
		else
			pP  = pN;
	if(pPP == NULL)
		if(pNN ==NULL)
			pPP = pC;
		else
			pPP = pNN;
	if(pN == NULL)
		if(pP ==NULL)
			pN  = pC;
		else
			pN  = pP;
	if(pNN == NULL)
		if(pPP ==NULL)
			pNN = pC;
		else
			pNN = pPP;

	pD  = (WORD*)fpip->ycp_temp;

	nPitch = fpip->max_w * 3;

	// tB^
	fp->exfunc->exec_multi_thread_func(DeDot_MT, (void *)&filter_param, NULL);

	// obt@
	PIXEL_YC *temp = fpip->ycp_edit;
	fpip->ycp_edit = fpip->ycp_temp;
	fpip->ycp_temp = temp;

#if	DEBUG
	debug_info(fpip, fp->exfunc);
#endif
	return TRUE;
}

